/*
 * ipcountry.c:
 * IP address to country lookup.
 *
 * Copyright (c) 2003 Chris Lightfoot. All rights reserved.
 * Email: chris@ex-parrot.com; WWW: http://www.ex-parrot.com/~chris/
 *
 */

static const char rcsid[] = "$Id: ipcountry.c,v 1.5 2003/12/06 16:25:56 chris Exp $";


#include <errno.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include <arpa/inet.h>
#include <netinet/in.h>

#include "ipcountry.h"
//#include "countrycodes.h"



int main(int argc, char *argv[]) {
    struct in_addr in;
    int printname = 0, ret = 1;
    ipcountry I;
    char code[3] = {0};
    
    if (argc == 3 && strcmp(argv[1], "-n") == 0) {
        printname = 1;
        ++argv;
    } else if (argc != 2) {
        fprintf(stderr, "ipcountry: syntax is ipcountry [-n] ip-address\n");
        return 1;
    }

    if (!inet_aton(argv[1], &in)) {
        fprintf(stderr, "ipcountry: `%s' is not a valid IP address\n", argv[1]);
        return 1;
    } else if (!(I = ipcountry_open(NULL))) {
        fprintf(stderr, "ipcountry: unable to open database (system error was: %s)\n", strerror(errno));
        return 1;
    }

    if (ipcr_ok == ipcountry_find(I, in, code)) {
        ret = 0;
        printf("%s", code);
        if (printname)
            printf(";%s", ipcountry_isocode_to_name(code));
        printf("\n");
    }

    ipcountry_close(I);

    return ret;
}
